import * as t from '@babel/types';
import { AttributeValueFormatter } from './base-builder';
import { BindingBuilder } from './binding-builder';
export declare class ComponentBuilder {
    private openTags;
    private pathsToResolve;
    private activeNamespaces;
    private usedNSTags;
    private componentName;
    private moduleRelativePath;
    private moduleDirPath;
    private platform;
    private attributeValueFormatter;
    private bindingBuilder;
    /**
     * Keep counter for the case of platform tags being inside platform tags.
     */
    private unsupportedPlatformTagCount;
    private platformTagNestingLevel;
    private treeIndex;
    private isComponentInitialized;
    private isInSlotFallbackScope;
    private moduleAst;
    private astBindingCallbacksBody;
    private astConstructorBody;
    private astCustomModuleProperties;
    private astCustomModulesRegister;
    constructor(moduleRelativePath: string, platform: string);
    setAttributeValueFormatter(callback: AttributeValueFormatter): void;
    setBindingBuilder(bindingBuilder: BindingBuilder): void;
    onTagOpening(tagName: string): void;
    onAttribute(name: string, value: string): void;
    onTagOpened(tagName: string, attributes: any): void;
    onTagClosing(tagName: string): void;
    getModuleAst(): t.Program;
    getPathsToResolve(): string[];
    private assembleAst;
    private isClosingTag;
    private checkOpenTagNestingConditions;
    private handleViewProperties;
    private getAttributeItem;
    private traverseAttributes;
    private getViewPropertySetterAst;
    private buildComponentAst;
    private generateComponentInitializationAstBody;
    private generateScriptAndStyleBindingAst;
    private generateBindingSourceAstCallback;
    private generateBindingCallbackDeclarations;
    private generateBindingTargetAstCallback;
    private registerNamespace;
    private getLocalAndPrefixByName;
    private getResolvedPath;
    private isViewProperty;
}
