"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setAbnormalStateReceiveListener = exports.notifyWarning = exports.notifyError = exports.AbnormalState = void 0;
const location_tracker_1 = require("./location-tracker");
var AbnormalState;
(function (AbnormalState) {
    AbnormalState[AbnormalState["ERROR"] = 0] = "ERROR";
    AbnormalState[AbnormalState["WARNING"] = 1] = "WARNING";
})(AbnormalState = exports.AbnormalState || (exports.AbnormalState = {}));
let listener = onAbnormalStateReceive;
function onAbnormalStateReceive(type, msg, range) {
    const { line, column } = range[0];
    throw new Error(`${msg}, at ${line}:${column}`);
}
function notifyError(msg) {
    const tracker = (0, location_tracker_1.getCurrentLocationTracker)();
    listener?.(AbnormalState.ERROR, msg, [
        tracker.getCurrentStartPosition(),
        tracker.getCurrentEndPosition()
    ]);
}
exports.notifyError = notifyError;
function notifyWarning(msg) {
    const tracker = (0, location_tracker_1.getCurrentLocationTracker)();
    listener?.(AbnormalState.WARNING, msg, [
        tracker.getCurrentStartPosition(),
        tracker.getCurrentEndPosition()
    ]);
}
exports.notifyWarning = notifyWarning;
function setAbnormalStateReceiveListener(value) {
    listener = value;
}
exports.setAbnormalStateReceiveListener = setAbnormalStateReceiveListener;
//# sourceMappingURL=compiler-abnormal-state.js.map